#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include        "tof77.h"

#include "compilerApi.h"


//add attribute statement in the first analyse ---------analyse1()
void add_attr_stmt(SgStatement * s)
 {  SgExpression * expr=NULL;
    SgExpression *var_list = s->expr(0);
    SgExpression *attr_list = s->expr(2);

    if(s->expr(2)!=NULL)
      {
         expr=s->expr(2);
         while(expr!=NULL)
           { 
            switch(expr->lhs()->variant())
              {
               case DIMENSION_OP:                 //dimension attribute doesn't add statement
                   {  SgExpression * exprlist=NULL;
                      SgExpression * ddot=expr->lhs()->lhs()->copyPtr();
                       
		      for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
                      {
			SgExpression * var= exp->lhs()->copyPtr();
                        if(var->variant()==VAR_REF)
                           { exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->symbol());
                             exp->setLhs(exprlist);
                            }
                         if(var->variant()==ASSGN_OP)
                             if(var->lhs()->variant()==VAR_REF)
                              { exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->lhs()->symbol());
                                exp->lhs()->setLhs(exprlist);
                              } 
                         if(var->variant()==STAR_LIST)
                            {  if(var->lhs()->variant()==VAR_REF)
                                {  exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->lhs()->symbol());
                                   exp->lhs()->setLhs(exprlist);
                                 } 
                              if(var->lhs()->variant()==ASSGN_OP)
                                 if(var->lhs()->lhs()->variant()==VAR_REF)
                                  { exprlist=new SgExpression(ARRAY_REF,ddot,NULL,var->lhs()->lhs()->symbol());
                                    exp->lhs()->lhs()->setLhs(exprlist);
                                  } 
                             }   
                      }

                      break;
                   }
                case PARAMETER_OP:            //parameter attribute adds statement
		      {	SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();

                          if(var->variant()==ASSGN_OP)
                            { var=var->lhs()->copyPtr();
                                 //clear assign_op
	       	              exp->setLhs(exp->lhs()->lhs());
                            } 
                           if(var->variant()==STAR_LIST)
                            { var=var->lhs()->lhs()->copyPtr();
                                 //clear assign_op
                              exp->lhs()->setLhs(exp->lhs()->lhs()->lhs());
                            }
                           
                          SgExpression *const_ref=new SgExpression(CONST_REF,NULL,NULL,var->symbol());
			  exprlist= new SgExpression(EXPR_LIST,const_ref,exprlist,NULL);
			}
                        SgStatement  * declStmt=new SgStatement(PARAM_DECL,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtAfter(*declStmt,*s->controlParent());
                        break;
                      }

                 case SAVE_OP:             //save attribute adds statement
		      {	
                        SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();
                              // clear assign_op
                          if(var->variant()==ASSGN_OP)
                               var=exp->lhs()->lhs()->copyPtr();
			  exprlist= new SgExpression(EXPR_LIST,var,exprlist,NULL);
                         }
                        SgStatement  * declStmt=new SgStatement(SAVE_DECL,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtBefore(*declStmt,*s->controlParent());
                        break;
                      }

                 
                 case EXTERNAL_OP:          //external attribute adds statement
		      {	
                        SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();
                              // clear assign_op
                          if(var->variant()==ASSGN_OP)
                               var=exp->lhs()->lhs()->copyPtr();
			  exprlist= new SgExpression(EXPR_LIST,var,exprlist,NULL);
                         }
                        SgStatement  * declStmt=new SgStatement(EXTERN_STAT,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtBefore(*declStmt,*s->controlParent());
                        break;
                      }
                 case INTRINSIC_OP:         //intrinsic attribute adds statement
		      {	
                        SgExpression *exprlist=NULL;
			for (SgExpression *exp= var_list ; exp ; exp=exp->rhs())
			{
			  SgExpression *var= exp->lhs()->copyPtr();
                              // clear assign_op
                          if(var->variant()==ASSGN_OP)
                               var=exp->lhs()->lhs()->copyPtr();
			  exprlist= new SgExpression(EXPR_LIST,var,exprlist,NULL);
                         }
                        SgStatement  * declStmt=new SgStatement(INTRIN_STAT,NULL,NULL,
                                   exprlist,NULL,NULL);
                        s->insertStmtBefore(*declStmt,*s->controlParent());
                        break;
                      }
                 case PUBLIC_OP:                 //these attributes don't add statement
                 case PRIVATE_OP:
                 case IN_OP:
                 case OUT_OP:
                 case INOUT_OP:
                 case TARGET_OP:
                         break;

                 case POINTER_OP:               //these attributes are saved
                 case OPTIONAL_OP:
                 case INHERIT_OP:
                 case DYNAMIC_OP:
                 case ALLOCATABLE_OP:
                     //do nothing
                      break;   
              }
             expr=expr->rhs();
          }
     }        
 }




//if variable is assigned initial value,
//add data statement in the second analyse-------analyse2() 
void add_data_stmt(SgStatement * s)
{
        SgExpression * var_list=s->expr(0);
        SgExpression * nlist=NULL, * clist=NULL, * exprlist=NULL, * set_list=NULL;
        
        for(SgExpression * exp=var_list; exp; exp=exp->rhs())
          {
            SgExpression * var=exp->lhs()->copyPtr();

            if(var->variant()==ASSGN_OP)
             { if(var->lhs()->variant()==VAR_REF)
                 {  clist=new SgExpression(DATA_VALUE,NULL,var->rhs(),NULL);
                    clist=new SgExpression(EXPR_LIST,clist,NULL,NULL);
                    nlist=new SgExpression(EXPR_LIST,var->lhs(),NULL,NULL);
                    set_list=new SgExpression(DATA_STMT_SET,nlist,clist,NULL);
                    exprlist=new SgExpression(EXPR_LIST,set_list,exprlist,NULL);
                    exp->setLhs(exp->lhs()->lhs());
                 }     //end of VAR_REF
              if(var->lhs()->variant()==ARRAY_REF)
                 { if(var->rhs()->variant()!=ARRAY_CONSTRUCTOR)
                   { int value=1;
                     for(SgExpression * expression=var->lhs()->lhs(); expression; expression=expression->rhs())
                      {
                        int value1=1,value2=1;
                        if(expression->lhs()->lhs()->lhs()!=NULL)
                           expression->lhs()->lhs()->lhs()->valueInteger(value1);
                        expression->lhs()->lhs()->rhs()->valueInteger(value2);
                        value=value*(value2-value1+1);
                      }
                     SgValueExp * int_val=new SgValueExp(value);
                     clist=new SgExpression(DATA_VALUE,int_val,var->rhs(),NULL);
                     clist=new SgExpression(EXPR_LIST,clist,NULL,NULL); 
                    }

                   if(var->rhs()->variant()==ARRAY_CONSTRUCTOR)
                   {
                     clist =var->rhs()->rhs()->copyPtr();
                     for(SgExpression * expression=clist; expression; expression=expression->rhs())
                     {  SgExpression * data_value=new SgExpression(DATA_VALUE,NULL,expression->lhs(),NULL);
                        expression->setLhs(data_value);
                      }
                   }     
                   nlist=new SgExpression(VAR_REF,NULL,NULL,var->lhs()->symbol());
                   nlist=new SgExpression(EXPR_LIST,nlist, NULL,NULL);
                   set_list=new SgExpression(DATA_STMT_SET,nlist,clist,NULL);
                   exprlist=new SgExpression(EXPR_LIST,set_list,exprlist,NULL);
                   exp->setLhs(exp->lhs()->lhs());
                 }    //end of ARRAY_REF
             }    //end of ASSGN_OP

                  //    type ------character
            if(var->variant()==STAR_LIST)
              if(var->lhs()->variant()==ASSGN_OP)
               { if(var->lhs()->lhs()->variant()==VAR_REF)
                  { clist=new SgExpression(DATA_VALUE,NULL,var->lhs()->rhs(),NULL);
                    clist=new SgExpression(EXPR_LIST,clist,NULL,NULL);
                    nlist=new SgExpression(EXPR_LIST,var->lhs()->lhs(),NULL,NULL);
                    set_list=new SgExpression(DATA_STMT_SET,nlist,clist,NULL);
                    exprlist=new SgExpression(EXPR_LIST,set_list,exprlist,NULL);
                    exp->lhs()->setLhs(exp->lhs()->lhs()->lhs());
                   } 
                if(var->lhs()->lhs()->variant()==ARRAY_REF)
                 { if(var->lhs()->rhs()->variant()!=ARRAY_CONSTRUCTOR)
                   { 
                     int value=1;
                     for(SgExpression * expression=var->lhs()->lhs()->lhs(); expression; expression=expression->rhs())
                      {
                        int value1=1,value2=1;
                        if(expression->lhs()->lhs()->lhs()!=NULL)
                           expression->lhs()->lhs()->lhs()->valueInteger(value1);
                        expression->lhs()->lhs()->rhs()->valueInteger(value2);
                        value=value*(value2-value1+1);
                      }
                     SgValueExp * int_val=new SgValueExp(value);
                     clist=new SgExpression(DATA_VALUE,int_val,var->lhs()->rhs(),NULL);
                     clist=new SgExpression(EXPR_LIST,clist,NULL,NULL); 
                    }

                   if(var->lhs()->rhs()->variant()==ARRAY_CONSTRUCTOR)
                   {
                     clist =var->lhs()->rhs()->rhs()->copyPtr();
                     for(SgExpression * expression=clist; expression; expression=expression->rhs())
                     {  SgExpression * data_value=new SgExpression(DATA_VALUE,NULL,expression->lhs(),NULL);
                        expression->setLhs(data_value);
                      }
                    }
                   nlist=new SgExpression(VAR_REF,NULL,NULL,var->lhs()->lhs()->symbol());
                   nlist=new SgExpression(EXPR_LIST,nlist, NULL,NULL);
                   set_list=new SgExpression(DATA_STMT_SET,nlist,clist,NULL);
                   exprlist=new SgExpression(EXPR_LIST,set_list,exprlist,NULL);
                   exp->lhs()->setLhs(exp->lhs()->lhs()->lhs());
                 }    //end of ARRAY_REF
               }   //end of STAR_LIST
          }   //end of for           
        if(exprlist!=NULL)
        {
          SgStatement *data_stmt=new SgStatement(DATA_DECL,NULL,NULL,exprlist,NULL,NULL);
          SgStatement *lastDeclStmt=s->lastDeclaration();
          lastDeclStmt->insertStmtAfter(*data_stmt,*s->controlParent());
        }

}


